<template>
  <div>
    <v-container>
      <v-row>
        <v-col cols="8">
          <v-responsive :aspect-ratio="1/1">
            <v-tooltip top>
              <template v-slot:activator="{ on }">
                <canvas ref="mycanvas" id="mycanvas" width="512"
                  height="512" v-on="on" @click="addSeed($event)">
                </canvas>
              </template>
              <span>Click on the canvas to insert a new seed</span>
            </v-tooltip>

          </v-responsive>
        </v-col>
        <v-col cols="4">
          <v-btn color="info" @click="resetData">Reset</v-btn>
          <v-radio-group v-model="metric" column label="Distance Metric">
            <v-radio label="Manhattan" value="1" />
            <v-radio label="Euclidean" value="2" />
            <v-radio label="Minkowski" value="3" />
            <v-slider v-model.number="power" :label="`Power ${power}`"
              v-show="metric >= 3" min="3" max="9" />
          </v-radio-group>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<script lang="ts">
/* eslint-disable */
import Vue from "vue";
import { Component, Watch } from "vue-property-decorator";
import * as THREE from "three";
import vertexShader from "../shaders/vs.glsl";
import fragmentShader from "@/shaders/fs.glsl";
import { BufferGeometry, BufferAttribute, Points } from "three";

const MAX_SEEDS = 100;
const GRID_SIZE = 3;

@Component
export default class WebGLPanel extends Vue {
  renderer: THREE.WebGLRenderer;
  scene: THREE.Scene;
  camera: THREE.OrthographicCamera;
  seedPoints: THREE.Points;
  planeMat: THREE.ShaderMaterial;
  numSeeds: number;
  seedColors: number[];
  seedLocations: number[];
  metric: string;
  power: number;
  numMetric: number;

  constructor() {
    super();
    this.renderer = null;
    this.planeMat = null;
    this.numSeeds = 2;
    this.seedLocations = new Array<number>(MAX_SEEDS * 3);
    this.seedColors = new Array<number>(MAX_SEEDS * 3);
    this.metric = "2";
    this.numMetric = 2;
    this.power = 3;
    // this.invProjView = new THREE.Matrix4();
    this.scene = new THREE.Scene();
    this.camera = new THREE.OrthographicCamera(
      -GRID_SIZE,
      GRID_SIZE,
      GRID_SIZE,
      -GRID_SIZE,
      1,
      100
    );
    this.camera.position.set(0, 0, 1);
    // this.viewPort = [];
  }

  // inspectShader(sh: THREE.Shader, r: THREE.WebGLRenderer) {
  //   console.log(sh);
  // }

  mounted() {
    const canvas = this.$refs.mycanvas as HTMLCanvasElement;
    // this.viewPort = [0, 0, canvas.width, canvas.height];
    this.renderer = new THREE.WebGLRenderer({ canvas, antialias: true });
    this.renderer.setPixelRatio(window.devicePixelRatio);

    // Define the four corners of the box
    const planeGeo = new THREE.BufferGeometry();
    const A = [-GRID_SIZE, -GRID_SIZE, 0];
    const B = [+GRID_SIZE, -GRID_SIZE, 0];
    const C = [+GRID_SIZE, +GRID_SIZE, 0];
    const D = [-GRID_SIZE, +GRID_SIZE, 0];
    // BufferGeometry draws GL.TRIANGLES, to create a square we have to use two triangles
    const vertexData = [...A, ...B, ...C, ...C, ...D, ...A];
    const vertexArr = new Float32Array(vertexData);
    const vertexAttr = new THREE.BufferAttribute(vertexArr, 3, false);
    planeGeo.setAttribute("position", vertexAttr);
    this.numSeeds = 2;

    for (let k = 0; k * this.numSeeds * 3; k++) {
      this.seedColors[k] = Math.random();
    }
    const pointArr = new Float32Array(MAX_SEEDS * 3);
    for (let k = 0; k < this.numSeeds * 3; k++) {
      this.seedColors[k] = Math.random();
      if (k != 2)
        this.seedLocations[k] = GRID_SIZE * Math.random();
      else
        this.seedLocations[k] = 0;
      pointArr[k] = this.seedLocations[k];
    }

    this.planeMat = new THREE.ShaderMaterial({
      uniforms: {
        seedColors: { value: this.seedColors },
        seedLocations: {
          // in the fragment shader, seedLocations is an array of vec2,
          // so we have skip the every third elements
          value: this.seedLocations
        },
        numSeeds: { value: this.numSeeds },
        metric: { value: this.numMetric }
      },
      vertexShader,
      fragmentShader
    });
    // planeMat.onBeforeCompile = this.inspectShader;
    const planeMesh = new THREE.Mesh(planeGeo, this.planeMat);
    this.scene.add(planeMesh);

    const pointGeo = new THREE.BufferGeometry();
    // const mvMatrix = new THREE.Matrix4();
    // mvMatrix.multiplyMatrices(this.camera.projectionMatrix, this.camera.matrix);
    // this.invProjView.getInverse(mvMatrix);
    pointGeo.setAttribute("position", new THREE.BufferAttribute(pointArr, 3));
    pointGeo.setDrawRange(0, this.numSeeds);
    const pointMat = new THREE.PointsMaterial({ color: 0x000000, size: 3 });
    this.seedPoints = new THREE.Points(pointGeo, pointMat);
    this.scene.add(this.seedPoints);

    this.camera.lookAt(planeMesh.position);
    requestAnimationFrame(() => this.renderIt());
  }

  renderIt() {
    this.renderer && this.renderer.render(this.scene, this.camera);
    requestAnimationFrame(() => this.renderIt());
  }

  resetData() {
    this.numSeeds = 2;
    const pointGeo = this.seedPoints.geometry as BufferGeometry;
    const pointAttr = pointGeo.attributes.position as BufferAttribute;
    const pointArr = pointAttr.array as Float32Array;
    pointGeo.setDrawRange(0, this.numSeeds);
    pointAttr.needsUpdate = true;
    const x1 = Math.random() * GRID_SIZE;
    const y1 = Math.random() * GRID_SIZE;
    const x2 = Math.random() * GRID_SIZE;
    const y2 = Math.random() * GRID_SIZE;
    console.log(`Reset to (${x1},${y1}) and (${x2},${y2})`);
    pointArr.set([x1, y1, 0, x2, y2, 0], 0);
    for (let k = 0; k < 3 * this.numSeeds; k++) {
      this.seedColors[k] = Math.random();
    }
    this.planeMat.uniforms.numSeeds.value = this.numSeeds;
    this.planeMat.uniforms.seedLocations.value = pointArr;
    requestAnimationFrame(() => this.renderIt());
  }

  addSeed(ev: MouseEvent) {
    // Return silently when we reach max capacity
    if (this.numSeeds > MAX_SEEDS) return;

    const cvs = this.$refs.mycanvas as HTMLCanvasElement;
    const x = 2 * GRID_SIZE * (ev.offsetX / cvs.width) - GRID_SIZE;
    const y = GRID_SIZE - (2 * GRID_SIZE * ev.offsetY) / cvs.height;
    console.debug(`New point at (${x.toFixed(2)},${y.toFixed(2)})`);
    const pointGeo = this.seedPoints.geometry as BufferGeometry;
    const pointAttr = pointGeo.attributes.position as BufferAttribute;
    const pointArr = pointAttr.array as Float32Array;

    // Calculate the random color luminosity to avoid "dark" colors
    let r, g, b;
    let luminosity;
    do {
      r = Math.random();
      g = Math.random();
      b = Math.random();
      luminosity = (r + r + b + g + g + g) / 6;
    } while (luminosity < 0.4);

    // Automatically set the .z value to 0
    pointArr.set([x, y, 0], 3 * this.numSeeds);
    this.seedColors.splice(3 * this.numSeeds, 9, r, g, b);
    this.numSeeds++;
    pointGeo.setDrawRange(0, this.numSeeds);
    pointAttr.needsUpdate = true;
    // pointGeo.computeBoundingSphere();
    this.planeMat.uniforms.seedLocations.value = pointArr;
    this.planeMat.uniforms.numSeeds.value = this.numSeeds;
    this.planeMat.needsUpdate = true;
  }

  @Watch("metric")
  onMetricChanged(value: string, oldValue: string) {
    this.numMetric = Number(value);
    this.planeMat.uniforms.metric.value = this.numMetric;
    requestAnimationFrame(() => this.renderIt());
  }

  @Watch("power")
  onPowerChanged(value: number, oldValue: number) {
    // this.numMetric = value;
    this.planeMat.uniforms.metric.value = value;
    requestAnimationFrame(() => this.renderIt());
  }

}
</script>

<style lang="scss" scoped>
#mycanvas {
  position: absolute;
  right: 0px;
}
</style>
